// простой барограф-3

extern "C"
{ void minit(void);     // инициализация портов и пр.
  void mslipping(void); // работа в экономичном режиме
  unsigned char getADC8(unsigned char nomeradc);
  unsigned char mknopki(void);
}

#include "Adafruit_GFX.h"    // Core graphics library
#include "Adafruit_ST7735.h" // Hardware-specific library
#include <SPI.h>

#define TFT_CS     10
#define TFT_RST    8
#define TFT_DC     9
// включим аппаратный SPI,
Adafruit_ST7735 tft = Adafruit_ST7735(TFT_CS,  TFT_DC, TFT_RST);

#define TFT_SCLK 13   // set these to be whatever pins you like!
#define TFT_MOSI 11   // set these to be whatever pins you like!
// но можно включить программный
//Adafruit_ST7735 tft = Adafruit_ST7735(TFT_CS, TFT_DC, TFT_MOSI, TFT_SCLK, TFT_RST);

#include <Wire.h>
#include "Adafruit_BMP085.h"
Adafruit_BMP085 bmp;

unsigned char chas = 0, mins = 0, sec = 0; // время
volatile unsigned char temper = 0;  // теммпература
unsigned char dawl[96];             // массив значений давления

// режим работы, 1 - питание от сети, 0 - работа от аккумулятора
unsigned char
  oldregim  = 0,  // предыдущее значение
  regim     = 0;  // текущее значение

volatile unsigned char VCC = 0, VCCB = 0; // калибровка напряжения переключения

void setup(void)
{
  minit();  // всеобщая инициализация

  Serial.begin(9600);
  Serial.print("Hello! ST7735 TFT Test");

  if (!bmp.begin())
  { Serial.println("Could not find a valid BMP085 sensor, check wiring!");
    while (1) {}
  }
  
// начальное заполнение массива - пила на экране
  unsigned char i = 0;
  for (i = 0; i < 96; i++) dawl[i] = (i % 48);
}

// работа с датчиком
void datchik(void)
{ unsigned char i = 0;
  if (((mins ==  2) && (sec == 10))||((mins == 32) && (sec == 10)))
  { temper = bmp.readTemperature();
    
    // сдвигаем данные в массиве
    for (i = 1; i < 96; i++)
    { dawl[i - 1] = dawl[i];
    }
    dawl[95] = bmp.readPressure() / 133.332 - 720;

    delay(1000);      // задержка против повторения опроса
    if (regim == 1)   // 1 - питание наличествует
    { grafik();
    }
  }
}

void loop()
{
  datchik();

  // проверим наличие питания
  unsigned char vcct = getADC8(14);

  if (vcct < 59)        // если питание есть
  {
    regim = 1;
    VCC = vcct;
    if (oldregim == 0)  // если питание от сети только что включилось
    {
      tft.initR(INITR_BLACKTAB);   // initialize a ST7735S chip, black tab
      ekran0();
      grafik();
    }
    showtime();
    delay(50);          // чтоб не так быстро
    if (mknopki() == 1) // если была нажата кнопка
    { showtime();
      delay(200);       // чтоб не так быстро
    }
  }
  else                  // питание отсутствует
  { regim = 0;
    VCCB = vcct;
    mslipping();        // "спящий" режим
  }

  oldregim = regim;
}

