#include "tft.h"

// формируем начальую картинку
void ekran0(void)
{
  tft.setRotation(2);
  tft.fillScreen(gBACK);         // тёмно-тёмносиний
  putstr(5,0,1,GRAY1,gBACK,"v.07072021");

  tft.drawLine(0, 10, 129, 10, WHITE);     // горизонталь сверху

  unsigned char i = 0, j = 70;
  
  String str;
  
  for (i = 30; i < 131; i += 20)
  { tft.drawLine(0, i, 129, i, GRAY1);     // серые горизонтали
    str = "7" + String(j);  
    putstr(110,i-9,1,GRAY1,gBACK,str);
    j -= 10;
  }

  tft.drawLine(0, 130, 129, 130, WHITE);  // горизонталь снизу
  tft.drawLine( 0, 11,  0, 130, WHITE);   // вертикаль слева
  tft.drawLine(98, 11, 98, 130, WHITE);   // вертикаль справа
}

void grafik(void)
{ unsigned char i = 0, j = 0, tmp;
  unsigned char gdedawl = 13;    // где рисовать давление (13-наверху, 100-внизу)

  unsigned char widgrafika = 1;    // просто линия или заполнение
  PORTD |= (1<<PD4);
  _delay_ms(50);
  if ((PIND & (1<<PD4)) == 0) widgrafika = 0;
  PORTD &= ~(1<<PD4);
  
  for (i = 0; i < 96; i++)
  {  
    if (i == 49) tft.drawLine(i+1,11, i+1, 129, GRAY1);    // суточная линия
    else tft.drawLine(i+1,11, i+1, 129, gBACK); // стиралка
    for (j = 30; j < 130; j += 20)
    { 
      tft.drawPixel(i+1,j, GRAY1);
    }

    if (widgrafika) 
      tft.drawPixel(i+1,130 - 2*dawl[i], WHITE);  // график ОСНОВНОЙ
    else 
      tft.drawLine(i+1,129, i+1, 129 - 2*dawl[i], 0b0000001111100000); // график залитый

    if (i > 48)
    { if (dawl[i] > 48) gdedawl = 100;  // ежели давление больше 768, рисуем внизу
    }
  } 
  
  tft.fillRect(99,11,7,119, gBACK);     // стиралка под столбиком 
  for (i = 30; i < 131; i += 20)
  { tft.drawLine(98, i, 129, i, GRAY1); // серые горизонтали
  }
  
  tmp = dawl[95] + dawl[95];
  tft.fillRect(99,130-tmp,7,tmp, RED);  // столбик

  String str = "T=+000C";
  str[3] = (temper / 10) + '0';
  str[4] = (temper % 10) + '0';
  str[5] = 247;
  putstr(74,0,1,WHITE,gBACK,str);  // температура

  str = "777";
  str[1] = ((dawl[95] + 20) / 10) + '0';
  str[2] = ((dawl[95] + 20) % 10) + '0';
  putstr(57,gdedawl,2,GREEN,gBACK,str);  // давление
}

// вывод времени
void showtime(void)
{
  String str = "00:00:00";

  str[0] = (chas / 10) + '0';
  str[1] = (chas % 10) + '0';
  str[3] = (mins / 10) + '0';
  str[4] = (mins % 10) + '0';
  str[6] = (sec / 10)  + '0';
  str[7] = (sec % 10)  + '0';
  putstr(18, 138, 2, YELLOW, gBACK, str);

  if (sec == 0)
  {
    tft.drawLine(0, 158, 120, 158, gBACK);
    tft.drawLine(0, 159, 120, 159, gBACK);
  }
// индикатор секунд
  tft.drawPixel(2 * sec, 158,YELLOW);  
  tft.drawPixel(2 * sec, 159,YELLOW);

// калибровка напряжения переключения
/*  str[0] = (VCC/10) + '0';
  str[1] = (VCC%10) + '0';
  str[2] = '*';
  str[3] = (VCCB/10) + '0';
  str[4] = (VCCB%10) + '0';
  str[5] = ':';
  str[6] = (sec/10) + '0';
  str[7] = (sec%10) + '0';
  str[8] = 0;
  putstr(10, 15, 1, WHITE, gBACK, str);
  */
// калибровка напряжения переключения
}

